package com.narvii.wallet

import com.fasterxml.jackson.databind.annotation.JsonDeserialize
import com.fasterxml.jackson.databind.annotation.JsonSerialize
import com.narvii.list.DateCompare
import com.narvii.model.NVObject
import com.narvii.util.JacksonUtils
import java.io.Serializable
import java.util.*

/**
 * Created by troy on 2018/7/23.
 */
class Coupon: NVObject(), DateCompare, Serializable {
    @JsonSerialize(using = JacksonUtils.DateSerializer::class)
    @JsonDeserialize(using = JacksonUtils.DateDeserializer::class)
    @JvmField var createdTime: Date? = null
    @JvmField var couponMappingId: String? = null
    @JvmField var coupon: CouponDetail? = null
    @JvmField var hasProperValue: Boolean = true

    override fun id(): String {
        return couponMappingId.orEmpty()
    }

    override fun objectType(): Int {
        return 0
    }

    override fun parentId(): String? {
        return null
    }

    override fun uid(): String? {
        return null
    }

    override fun status(): Int {
        return 0
    }

    override fun getCompareDate(): Date {
       return if (createdTime == null) Date() else createdTime!!
    }

    fun getValue(): Int {
        return if (coupon != null) coupon!!.getValue() else 0
    }

    fun getCouponTitle(): String {
        return coupon?.getCouponTitle().orEmpty()
    }

    fun getCouponScopeDesc(): String {
        return coupon?.getCouponScopeDesc().orEmpty()
    }

    fun isAvailable(): Boolean {
        return true
    }
}